package cz.cvut.fel.pr1;

import java.util.Scanner;

public class TextIO {

   private Scanner stdin;
   private String filename;
   private Scanner file;
   private String[] values;

   public TextIO() {
      stdin = new Scanner(System.in);
   }

   public static boolean isInteger(String s) {
      boolean ret = true;
      try {
	 Integer.parseInt(s);
      } catch (NumberFormatException e) {
	 ret = false;
      }
      return ret;
   }

   public static boolean isDouble(String s) {
      boolean ret = true;
      try {
	 Double.parseDouble(s);
      } catch (NumberFormatException e) {
	 ret = false;
      }
      return ret;
   }

   public String getLine() {
      return stdin.hasNext() ? stdin.nextLine() : "";
   }

   public void demo() {
      System.out.println("Demo of the TextIO class");
      System.out.print("Enter a line(number or a word): ");
      String line = getLine();
      if (isInteger(line)) {
	 System.out.println("The line represents integer");
      } else if (isDouble(line)) {
	 System.out.println("The line represents double");
      } else {
	 System.out.println("The line is a general string");
      }
   }

   public static void main(String[] args) {
      TextIO txtIO = new TextIO();
      txtIO.demo();
   }

}
