package cz.cvut.fel.pr1;

import java.util.Objects;
import java.awt.Color;

/**
 *
 * @author jf
 */
public abstract class Geom {

    /**
     *
     */
    protected Color color;

    /**
     *
     * @param color
     */
    public Geom(Color color) {
        this.color = color;
    }

    /**
     *
     * @param geom
     * @return
     */
    public abstract boolean isEqual(Geom geom);

    /**
     *
     * @param geom
     * @return
     */
    public abstract boolean isInside(Geom geom);

    /**
     *
     * @return
     */
    public Color getColor() {
        return color;
    }

    /**
     *
     * @param color
     */
    public void setColor(Color color) {
        this.color = color;
    }

    @Override
    public String toString() {
        return "Geom{shape=" + getShapeName() + ",color=" + color + '}';
    }

    /**
     *
     * @return string representation of the shape name
     */
    public abstract String getShapeName();

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 17 * hash + Objects.hashCode(this.color);
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Geom other = (Geom) obj;
        if (!Objects.equals(this.color, other.color)) {
            return false;
        }
        return isEqual(other);
    }
}
